﻿Type=Service
Version=5.78
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private cache As Map
	Private tasks As Map
	Private ongoingTasks As Map
	Private const ADD_PROGRESSBAR As Boolean = True
End Sub

Sub Service_Create
	tasks.Initialize
	cache.Initialize
	ongoingTasks.Initialize
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Sub Service_Destroy

End Sub

Sub Download (ImageViewsMap As Map)
	For Each iv As ImageView In ImageViewsMap.Keys
		Dim link As String = ImageViewsMap.Get(iv)
		Dim o As Object = iv
		tasks.Put(o, link)
		If cache.ContainsKey(link) Then
			iv.SetBackgroundImage(cache.Get(link))
		Else If ongoingTasks.ContainsKey(link) = False Then
			ongoingTasks.Put(link, "")
			Dim j As HttpJob
			j.Initialize(link, Me)
			j.Download(link)
			If ADD_PROGRESSBAR Then
				Dim pb As ProgressBar
				pb.Initialize("")
				pb.Indeterminate = True
				Dim parent As Panel = iv.Parent
				iv.Tag = pb
				parent.AddView(pb, iv.Left, iv.Top, iv.Width, iv.Height)
			End If
		End If
	Next
End Sub

Sub JobDone(Job As HttpJob)
	ongoingTasks.Remove(Job.JobName)
	If Job.Success Then
		Dim bmp As Bitmap = Job.GetBitmap
		cache.Put(Job.JobName, bmp)
		If tasks.IsInitialized Then
			For i = 0 To tasks.Size - 1
				Dim link As String = tasks.GetValueAt(i)
				If link = Job.JobName Then
					Dim iv As ImageView = tasks.GetKeyAt(i)
					iv.SetBackgroundImage(bmp)
					If ADD_PROGRESSBAR And iv.Tag Is ProgressBar Then
						Dim pb As ProgressBar = iv.Tag
						pb.RemoveView
					End If
				End If
			Next
		End If
	Else
		Log("Error downloading image: " & Job.JobName & CRLF & Job.ErrorMessage)
	End If
	Job.Release
End Sub
Sub ActivityIsPaused
	tasks.Clear
End Sub
